from enum import Enum


class Type(Enum):

    """
    An enumeration of the possible types we might have in term of algorithm understanding
    CONTINUOUS: a range of values
    NOMINAL: categorical values e.g. A+, A, B, C, D ...
    NOMINAL_ONE: same as the previous one, but we deal with them as one against all
    TIMESERIES: Timeseries of continuous values
    TIMESERIES_NOMINAL: Timeseries of categorical values
    TIMESTAMP
    PATTERN: same as continuous but has more information
    """

    # Standard float/int values (string needs a special treatment)
    CONTINUOUS = 'continuous'

    # No intrinsic ordering in the values
    # e.g. in decision tree, the split is not binary but depending on the number of available values
    NOMINAL = 'nominal'
    # Same as the one before, but we deal with it as one against all
    # e.g. in decision tree, it forces a binary split
    NOMINAL_ONE = 'nominal_one'

    # Special type of feature
    TIMESERIES = 'timeseries'
    TIMESTAMP = 'timestamp'

    # Same as continuous but with more information on the pattern behind the feature (generated by HARP)
    PATTERN = 'pattern'
